<script lang="ts">
import Vue from 'vue';
import {
  IsMobileMixin,
  UseLiteVimeo,
  UseLocalizedVideoSubtitles,
} from '~/mixins';
import VideoModal from '~/components/solutions/video-modal.vue';

export default Vue.extend({
  name: 'CodeSuggestionsSaleshero',
  components: {
    VideoModal,
  },
  mixins: [IsMobileMixin, UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data: () => ({
    showModal: false,
  }),
  methods: {
    openModal() {
      this.showModal = true;
    },
  },
});
</script>

<template>
  <div class="gitlab-duo-sales-hero">
    <img
      class="gitlab-duo-sales-hero__bg-image"
      preload
      :src="data.backgroundImage.src"
    />
    <SlpContainer class="gitlab-duo-sales-hero__container">
      <SlpRow class="gitlab-duo-sales-hero__row">
        <SlpColumn
          class="gitlab-duo-sales-hero__copy gitlab-duo-sales-hero__col"
        >
          <div
            :data-aos="isMobile ? null : 'fade-down'"
            :data-aos-duration="isMobile ? null : '1600'"
            :data-aos-offset="isMobile ? null : '0'"
          >
            <div>
              <img
                class="duo-logo"
                src="https://images.ctfassets.net/xz1dnu24egyd/53LwJs3htvp8oKk1A3Gh1c/e6af43a0286f084041e5dfe7200e7a92/duo-logo.svg"
              />
              <SlpTypography v-if="data.blurb" variant="heading5-bold">
                {{ data.blurb }}
              </SlpTypography>
            </div>

            <SlpTypography
              tag="h1"
              variant="heading2-bold"
              class="title slp-mt-16"
            >
              {{ data.title }}
            </SlpTypography>
            <SlpTypography
              v-if="data.subheader"
              tag="h5"
              variant="heading5"
              class="slp-pt-16 description"
            >
              {{ data.subheader }}
            </SlpTypography>
            <SlpButton
              v-if="data.button"
              variant="tertiary"
              :data-ga-name="data.button.data_ga_name"
              :data-ga-location="data.button.data_ga_location"
              class="slp-mt-24 slp-mr-24"
              @click.native="openModal()"
            >
              {{ data.button.text }}
              <SlpIcon
                name="play-circle-outline"
                variant="marketing"
                size="md"
              ></SlpIcon>
            </SlpButton>
            <SlpButton
              v-if="data.primaryButton"
              :variant="data.primaryButton.variant"
              :data-ga-name="data.primaryButton.variant"
              :data-ga-location="data.primaryButton.variant"
              :href="data.primaryButton.href"
              class="slp-mt-24 slp-mr-24 slp-btn--primary"
            >
              {{ data.primaryButton.text }}
              <SlpIcon
                v-if="data.primaryButton.icon"
                :name="data.primaryButton.icon.name"
                :variant="data.primaryButton.icon.variant"
                size="sm"
              />
            </SlpButton>
          </div>
        </SlpColumn>
      </SlpRow>
      <VideoModal
        v-if="data.video?.url"
        v-show="showModal && data.video?.url"
        light-background
        :visible="showModal"
        @close="showModal = false"
      >
        <template #body>
          <lite-vimeo
            :videoid="getVimeoVideoId(createVideoSource(data.video?.url))"
            title="Video"
            autoplay
          ></lite-vimeo>
        </template>
      </VideoModal>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.gitlab-duo-sales-hero {
  color: $color-text-50;
  position: relative;
  line-height: 0%;
  background-color: $color-surface-700;

  .duo-logo {
    height: 24px;
  }

  .description {
    color: $color-surface-400;
    max-width: 540px;
  }

  &__row {
    position: absolute;
    transform: translateY(-50%);
    top: 50%;
    width: 90%;
  }

  &__bg-image {
    width: 100%;
    object-fit: cover;

    @media (max-width: $breakpoint-lg) {
      min-height: 500px;
      object-fit: cover;
    }
  }

  &__col {
    height: 100%;
    min-height: 100%;
    width: 100%;

    @media (max-width: $breakpoint-lg) {
      flex: 1 1 100%;
      width: 100%;
    }
  }

  &__copy {
    padding: $spacing-64 0;
    z-index: 1000;

    @media (max-width: $breakpoint-md) {
      padding-top: $spacing-96;
    }
  }
}

.slp-btn {
  color: $color-text-50;
  padding: $spacing-8 $spacing-16 $spacing-8 0;
  font-size: 18px;

  &:hover {
    text-decoration: underline;

    svg {
      transition: transform 0.4s ease;
      transform: translateX($spacing-8);
    }
  }

  svg {
    margin-left: $spacing-8;
  }

  &--primary {
    border-radius: 4px;
    border: 1px solid $color-surface-50;
    padding-left: $spacing-16;
  }
}

.modal {
  background: transparent;
  display: flex;
  flex-direction: column;
  margin-top: $spacing-160;

  &__backdrop {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba($color-surface-700, 0.85);
    display: flex;
    justify-content: center;
    align-items: flex-start;
    z-index: 1040;
  }
}
</style>
